# -*- coding: utf-8 -*-
"""
Created on Sat Mar 21 07:39:58 2020

@author: Ismail
"""
import pandas as pd
import numpy as np
import scikitplot as skplt
import matplotlib.pyplot as plt
import time

data = pd.read_csv('all.csv')
X = data.drop('OUTPUT', axis =1)
y = data['OUTPUT']

from sklearn.model_selection import train_test_split
X_train,X_test,y_train,y_test = train_test_split(X, y, test_size=0.3,random_state=42, stratify = y)

X_train_new = X_train.iloc[:,[1,2]] #This one is obtained from the 5 best selected features
X_test_new = X_test.iloc[:,[1,2]]

from sklearn.neighbors import KNeighborsClassifier
knn=KNeighborsClassifier()

t0=time.time()
knn_a= knn.fit(X_train,y_train)
print ("training time:", round(time.time()-t0, 3), "s")

t0=time.time()
yfit_train_a = knn_a.predict(X_train)
print ("prediction training time:", round(time.time()-t0, 3), "s")

yfit_test_a = knn_a.predict(X_test)


from sklearn.metrics import classification_report
#import scikitplot as skplt
print("From all features")
print(classification_report(y_train, yfit_train_a))
print(classification_report(y_test, yfit_test_a))
skplt.metrics.plot_confusion_matrix(y_test, yfit_test_a)

#%%
t0=time.time()
knn_s= knn.fit(X_train_new,y_train)
print ("training time:", round(time.time()-t0, 3), "s")

t0=time.time()
yfit_train_s = knn_a.predict(X_train_new)
print ("prediction training time:", round(time.time()-t0, 3), "s")

yfit_test_s = knn_a.predict(X_test_new)

print("From 5 best features")
print(classification_report(y_train, yfit_train_s))
print(classification_report(y_test, yfit_test_s))
skplt.metrics.plot_confusion_matrix(y_test, yfit_test_s)

# #%%Hyperparameter Optimisation
# from sklearn.model_selection import GridSearchCV
# #from sklearn.metrics import accuracy_score,precision_score,recall_score
# #from sklearn.model_selection import cross_val_score

# #dir(KNeighborsClassifier)

# k_range = range(1,28)
# knn=KNeighborsClassifier()
# parameters = {'n_neighbors': k_range, 
#               'metric': ['euclidean','manhattan','minkowski','chebyshev']}
# cv=GridSearchCV(knn,parameters,cv=5)
# t0=time.time()
# knn_c=cv.fit(X_train_new,y_train.values.ravel())
# print ("training time:", round(time.time()-t0, 3), "s")

# def print_results(results):
#     print('Best Param: {}\n'.format(results.best_params_))
#     means = results.cv_results_['mean_test_score']
#     stds = results.cv_results_['std_test_score']
#     for mean, std, params in zip(means,stds, results.cv_results_['params']):
#         print('{} (+/-{}) for {}'.format(round(mean,3),round(std*2,3),params))
        
# print_results(cv)

# cv.best_estimator_

# t0=time.time()
# yfit_train_c = knn_c.predict(X_train_new)
# print ("prediction training time:", round(time.time()-t0, 3), "s")

# yfit_test_c = knn_c.predict(X_test_new)

# print("From 5 best features and hyper-parameter")
# print(classification_report(y_train, yfit_train_c))
# print(classification_report(y_test, yfit_test_c))
# skplt.metrics.plot_confusion_matrix(y_test, yfit_test_c)


#%%
# import matplotlib.pyplot as plt

# plt.plot(k_range, cv.cv_results_['mean_test_score'])
# plt.xlabel('Value of k for kNN', fontsize = 12 )
# plt.ylabel('Testing Accuracy',  fontsize = 12)


